/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.fleet;

import java.util.ArrayList;
import java.util.List;
import nl.cloudfarming.client.fleet.model.*;
import org.netbeans.api.project.Project;
import org.openide.util.Lookup;
import org.openide.util.lookup.ServiceProvider;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
@ServiceProvider(service = MachineService.class)
public class MachineServiceImpl implements MachineService {

    @Override
    public List<Machine> getMachines(Project fleetProject) {
        List<Machine> machines = new ArrayList<>();
        
        Lookup.Result<VehicleService> vehicleServices = Lookup.getDefault().lookupResult(VehicleService.class);
        for(VehicleService provider: vehicleServices.allInstances()) {
            machines.addAll(provider.getMachines(fleetProject));
        }
        
        Lookup.Result<ImplementService> implementServices = Lookup.getDefault().lookupResult(ImplementService.class);
        for(ImplementService provider: implementServices.allInstances()) {
            machines.addAll(provider.getMachines(fleetProject));
        }
        
        return machines;
    }
}
